/*****************************************************************************
 * resizer.c : DaVinci resizer
 *****************************************************************************
 * Copyright © 2010 Rafaël Carré
 *
 * Authors: Rafaël Carré <rafael at gmail>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 *****************************************************************************/

#ifndef VLC_DAVINCI_RESIZER_H
#define VLC_DAVINCI_RESIZER_H 1

#include <inttypes.h>
#include <assert.h>

typedef struct resizer_t davinci_resizer_t;

void resizer_close(struct resizer_t *rsz);

struct resizer_t *resizer_open(vlc_object_t *p_this,
        int in_width, int in_height,
        int *out_width, int *out_height);

int resizer_resize(vlc_object_t *p_this,
        struct resizer_t *rsz, uint8_t *in, uint8_t *out);

void resizer_copy_picture(vlc_object_t *p_this,
        uint8_t *out, uint8_t *in, int width, int height);

/** FIXME: arbritary values make them more configurable */
#define OUT_WIDTH  720
#define OUT_HEIGHT 480

/* define if VLC picture buffers are allocated with Memorycontig_Alloc() */
#define DIRECT_OUTPUT

#endif /* VLC_DAVINCI_RESIZER_H */
